Attribute VB_Name = "BinHex"
Option Explicit



'//////////////////////////////////////////////////////////////////////////////////////////////////
'// from decimal

Public Function DecToBin(ByVal val As Long) As String
    Dim i As Long
    Dim j As Long
    Dim res As String

    If val = 0 Then
        res = "0"
    Else
        Do Until val = 0
            If val And 1 Then
                res = "1" + res
            Else
                res = "0" + res
            End If
            val = val \ 2
        Loop
    End If

    DecToBin = res
End Function

Public Function DecToHex(val As Long) As String
    DecToHex = Hex(val)
End Function

Public Function DecToChar(ByVal val As Long) As String
    Dim res As String

    If val = 0 Then
        res = " "
    Else
        Do Until val = 0
            res = Chr(val And 255) + res
            val = val \ 8
        Loop
    End If

    DecToChar = res
End Function



'//////////////////////////////////////////////////////////////////////////////////////////////////
'// from binary

Public Function BinToDec(val As String) As Long
    Dim res As Long
    Dim i As Long
    
    For i = 1 To Len(val)
        res = res * 2
        If Mid(val, i, 1) = "1" Then res = res + 1
    Next i

    BinToDec = res
End Function

Public Function BinToHex(val As String) As String
    BinToHex = DecToHex(BinToDec(val))
End Function

Public Function BinToChar(val As String) As String
    BinToChar = DecToChar(BinToDec(val))
End Function



'//////////////////////////////////////////////////////////////////////////////////////////////////
'// from hexadecimal

Public Function HexToDec(val As String) As Long
    HexToDec = "&H" + val
End Function

Public Function HexToBin(val As String) As String
    HexToBin = DecToBin("&H" + val)
End Function

Public Function HexToChar(val As String) As String
    HexToChar = DecToChar("&H" + val)
End Function



'//////////////////////////////////////////////////////////////////////////////////////////////////
'// from char (4 chars maximum

Public Function CharToDec(val As String) As Long
    Dim i As Long
    Dim res As Long

    For i = 1 To Len(val)
        res = res * 256
        res = res + Asc(Mid(val, i, 1))
    Next i

    CharToDec = res
End Function

Public Function CharToBin(val As String) As String
    CharToBin = DecToBin(CharToDec(val))
End Function

Public Function CharToHex(val As String) As String
    CharToHex = DecToHex(CharToDec(val))
End Function
